typedef enum {
	GENERATED,PCM
} OType;

typedef struct {
	int offset;
	int datalen;
	char *data;
} hdata;

typedef struct {
	char *title;
	int length;
} finfo;

typedef struct {
	bool eof;
	int type;
	unsigned char *ptr1;
	unsigned char *ptr2;
	unsigned int freq[2];
	unsigned int tf[2];
	unsigned long period[2];
	signed int stat[2];
} adata;

typedef struct {
	OType type;	/* PCM or generated? */
	char *desc;	/*description*/
	bool (*checkfile) (char *filename); 	/* check filename extention */
	hdata (*head) (char *filename);	/* check internal program headers */
	adata (*set_pointers) (unsigned char *ptr,adata temp);	/* configure pointers before playing begins */
	adata (*read_data) (adata data);	/* read data from file to form plugin can use */
	finfo (*fileinfo) (char *filename);	/* return title and length of the audio file, and data offset in the file */
} fdata;
